unit Main;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, GDIPAPI, GDIPOBJ, Math, Vcl.ExtCtrls, Vcl.StdCtrls, Vcl.ExtDlgs,
  system.UITypes;

type
  TForm1 = class(TForm)
    rotationBtn: TButton;
    Image1: TImage;
    FileOpenBtn: TButton;
    OpenPictureDialog1: TOpenPictureDialog;
    FileSaveBtn: TButton;
    SavePictureDialog1: TSavePictureDialog;
    RotationEdit: TLabeledEdit;
    procedure rotationBtnClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FileOpenBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileSaveBtnClick(Sender: TObject);
  private
    { Private 錾 }
  public
    { Public 錾 }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses WicFileSave;

var
  Indeg       : Double;
  VRect       : Trect;
  GHeight     : Integer;
  GWidth      : Integer;
  InFilename  : String;
  Dbitmap     : Tbitmap;
  InBitmap    : Tbitmap;

const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

{
// TGPImage FileSave Format
  ibmp  = 'image/bmp';
  ijpeg = 'image/jpeg';
  igif  = 'image/gif';
  itiff = 'image/tiff';
  ipng  = 'image/png';
}

procedure TForm1.rotationBtnClick(Sender: TObject);
var
  Angle   : Extended;
  Gpgraph : TGPGraphics;
  GImage  : TGPImage;
  Points  : array[0..3] of TGPPointF;
  I: Integer;
  W, H: Double;
  X, Y, MinX, MinY: Double;
  IHeight     : Integer;
  IWidth      : Integer;
  Astream     : TMemoryStream;

begin
  Val(Rotationedit.Text, Indeg, I);
  if I <> 0 then begin
    application.MessageBox('͒lɌ肪܂B','', 0);
    exit;
  end;
  Indeg := - Indeg;                                           // windowsʂ Y tȂ̂ŕς܂B@
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnFace;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  Angle := DegToRad(Indeg);                                   // ]px
  W := abs(sin(Angle)) * GHeight + abs(cos(Angle)) * GWidth;  // ]̃rbg}bvvZ
  H := abs(cos(Angle)) * GHeight + abs(sin(Angle)) * GWidth;  // ]̃rbg}bvvZ

  Dbitmap.Assign(nil);                                        // TBitmap̏
  Dbitmap.PixelFormat := pf24bit;                             // TBitmap̃tH[}bgݒ
  Dbitmap.SetSize(Round(W), Round(H));                        // TBitmap̑傫ݒ

  IWidth  := Image1.Width;
  IHeight := Image1.Height;
  if H <= W then begin                                        // ]̏cŕ\TCYݒ
    IHeight := Round(IWidth * H / W);
  end
  else
  begin
    IWidth := Round(IHeight * W / H);
  end;
  VRect := Rect(0, 0, IWidth, IHeight);                       // \TCYݒ

  Gpgraph := TGPGraphics.Create(Dbitmap.Canvas.Handle);       // GD+TBitmap̕`nhݒ

  // [Xg[쐬 inbitmap o
  Astream  := TMemoryStream.Create;
  InBitmap.SaveToStream(Astream);
  // [Xg[CTGPBitmap̃IuWFNgɓǂݍݎw
  GImage := TGPBitmap.Create(TStreamAdapter.Create(AStream, soReference));
//  GImage := TGPImage.Create(InFilename);                      // TGPImageɃt@C֘At
  try
    { ]Ỏ摜̒_W }
    W := GImage.GetWidth;                                     // 摜̕擾
    H := GImage.GetHeight;                                    // 摜̍擾
    Points[0] := MakePoint(0.0, 0.0);                         // XYW^̔zɉ摜lWݒ 
    Points[1] := MakePoint(  W, 0.0);                         // E
    Points[2] := MakePoint(0.0, H);                           // 
    Points[3] := MakePoint(  W, H);                           // E ݒ͂Ă邪̃|Cg͎gp܂

    MinX := 0.0;
    MinY := 0.0;

    { ]̉摜̒_WvZ }
    for I := 0 to 3 do                                              // ŏ̍W X = 0 Y =0 Ȃ̂ŌvZ͂ȂĂOk
    begin
      X := (Cos(Angle) * Points[I].X - Sin(Angle) * Points[I].Y);   // ]̂wWvZ
      Y := (Sin(Angle) * Points[I].X + Cos(Angle) * Points[I].Y);   // ]̂xWvZ
      Points[I] := MakePoint(X, Y);                                 // XYW^̔zɉ摜lWݒ
      if X < MinX then MinX := X;                                   // 摜Vtgׂ̈wŏl
      if Y < MinY then MinY := Y;                                   // 摜Vtgׂ̈xŏl
    end;

    { Tbitmapɕ`悳悤WVtg܂ }
    for I := 0 to 3 do
    begin
      Points[I].X := Points[I].X - MinX;
      Points[I].Y := Points[I].Y - MinY;
    end;

    { ` }
    Gpgraph.DrawImage(GImage, PGPPointF(@Points), 3);               // w肳ꂽO_ɍ킹 DbitmapGImage]}
    Image1.Canvas.StretchDraw(Vrect, Dbitmap);                      // Image1 Dbitmapϔ{\
  finally
    Astream.Free;
    GImage.Free;                          // C^[tFCX^̃IuWFNgȂ̂ŁC͊{Iɕsv
    Gpgraph.Free;                         // ėpꍇ͉܂B
  end;
  Filesavebtn.Enabled := True;
end;

procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  IHeight     : Integer;
  IWidth      : Integer;
begin
  FileOpenBtn.Enabled := False;
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnFace;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜
  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾 ]ɂgp
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        InBitmap.Assign(nil);                                 // ꉞ
        InBitmap.Assign(WiC);                                 // WICf[^[Rs[

        IWidth  := Image1.Width;                              // o͐C[W1̕
        IHeight := Image1.Height;                             // o͐C[W1̍
        if GHeight <= GWidth then begin                       // cɂo̓TCYݒ
          IHeight := Round(IWidth * GHeight / GWidth);
        end
        else
        begin
          IWidth := Round(IHeight * GWidth /GHeight);
        end;
        VRect := Rect(0, 0, IWidth, IHeight);                 // o͘gݒ
        Image1.Canvas.StretchDraw(VRect, InBitmap);           // o͘gɕϔ{o
      finally
        WIC.Free;
      end;
    end;
  FileOpenBtn.Enabled := True;
  rotationbtn.Enabled := True;
end;

procedure TForm1.FileSaveBtnClick(Sender: TObject);
var
  WIC     : TWicImage;
  WICF    : TWicImageFormat;

  Fname   : String;
  ExeStr  : String;
  FnameTop: String;
  Findex  : integer;

  function WFormatSet: Boolean;                                            // gqɂt@CtH[}bgݒ
  begin
    Result := false;
    ExeStr := LowerCase(ExeStr);
    if ExeStr = '.jpg'  then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.jpeg' then  begin WICF := Wifjpeg; Result := True; end;
    if ExeStr = '.tif'  then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.tiff' then  begin WICF := Wiftiff; Result := True; end;
    if ExeStr = '.png'  then  begin WICF := Wifpng;  Result := True; end;
    if ExeStr = '.gif'  then  begin WICF := Wifgif;  Result := True; end;
    if ExeStr = '.bmp'  then  begin WICF := Wifbmp;  Result := True; end;
    if ExeStr = '.wdp'  then  begin WICF := WifWMPhoto; Result := True; end;
    if ExeStr = '.hdp'  then  begin WICF := WifWMPhoto; Result := True; end;
  end;

begin
  SavePictureDialog1.Filter := SaveFileFilter;
//  SavePictureDialog1.DefaultExt := GraphicExtension(TWicImage);
  if not SavePictureDialog1.Execute then exit;
  ExeStr := ExtractFileExt(SavePictureDialog1.FileName);
  if ExeStr = '' then begin                                                // gqȂ
    Findex := SavePictureDialog1.FilterIndex;                              // FilterIndexɂgq̐ݒ
    case Findex of
      1, 3 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.jpg');   // gq̐ݒ
         2 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.png');   // gq̐ݒ
         4 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.gif');   // gq̐ݒ
         5 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.bmp');   // gq̐ݒ
         6 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.tif');   // gq̐ݒ
         7 : Fname := ChangeFileExt(SavePictureDialog1.FileName,'.wdp');   // gq̐ݒ
    end;
  end
  else
    Fname := SavePictureDialog1.FileName;
  ExeStr := ExtractFileExt(Fname);                                         // gqo
  if not WFormatSet then begin                                             // gqɂt@CtH[}bgݒƊmF
    application.MessageBox('t@C̊gqԈĂ܂B','', 0);
    exit;
  end;
  FnameTop := ExtractFileName(Fname);                                      // t@Co
  if Length(FnameTop) = Length(ExeStr) then begin                          // t@C̒mF
    application.MessageBox('t@C܂B','', 0);
    exit;
  end;

  if FileExists(Fname) then                                                // t@Cɂt@C
    if MessageDlg('ɓÕt@C܂㏑܂ ' + ExtractFileName(Fname) + '?',
                                                      mtConfirmation, [mbYes, mbNo], 0, mbNo) = IDNo then exit;

  WIC := TWicImage.Create;                                                 // TWicImage
  try
    WIC.Assign(Dbitmap);                                                   // TWicImageɃrbg}bvf[^[t
    WIC.ImageFormat := WICF;                                               // ۑtH[}bgZbg
    WIC.FixedSaveTofile(Fname);                                            // t@C̏o
  finally
    WIC.Free;                                                              // TWicImage
  end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  Bitmapd: Tbitmap;
begin
  Top   := (Screen.Height - Height) div 2;
  Left  := (Screen.Width - Width)   div 2;
  Bitmapd   := Tbitmap.Create;              // Bitmap쐬
  try
    Image1.Width := 600;
    Image1.Height := 600;
    Bitmapd.Width := Image1.Width;
    Bitmapd.Height := Image1.Height;
    Image1.Picture.Graphic := Bitmapd;      // GraphicBitmap̊t ꂪȂƌImage1̃TCYύXoȂ
  finally                                   // ̃vOł͂ȂĂ@TCYύXĂ܂
    Bitmapd.Free;                           // Bitmap̊J
  end;
//  image1.Picture.Bitmap.SetSize(600, 600);
  Dbitmap   := Tbitmap.Create;              // ƗpBitmap쐬
  InBitmap  := Tbitmap.Create;              // 摜͗pBitmap쐬
  rotationbtn.Enabled := False;
  Filesavebtn.Enabled := False;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  InBitmap.Free;
  Dbitmap.Free;
end;

end.
