unit RMain;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.ExtCtrls, Vcl.ExtDlgs, Vcl.StdCtrls, Vcl.Buttons, System.Math;

type
  TForm1 = class(TForm)
    Image1: TImage;
    FileOpenBtn: TBitBtn;
    OpenPictureDialog1: TOpenPictureDialog;
    Rotationbtn: TButton;
    DeginEdit: TLabeledEdit;
    CheckBox1: TCheckBox;
    ScrollBar1: TScrollBar;
    Label1: TLabel;
    ScrollBar2: TScrollBar;
    Label2: TLabel;
    Timer1: TTimer;
    CheckBox2: TCheckBox;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FileOpenBtnClick(Sender: TObject);
    procedure RotationbtnClick(Sender: TObject);
    procedure ScrollBar1Change(Sender: TObject);
    procedure ScrollBar2Change(Sender: TObject);
  private
    { Private 錾 }
    procedure MakeLookUp;
  public
    { Public 錾 }
    function LooK_UP(diff: Smallint; Ki, Bas: Byte): byte;
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

var
  InputDBitmap  : TBitmap;                    // ̓f[^[\prbg}bv
  OutputBitmap  : TBitmap;                    // ]摜\prbg}bv
  GHeight       : Integer;                    // ̓f[^[摜
  GWidth        : Integer;                    // ̓f[^[摜

  VRect         : Trect;                      // \TCYݒp
  InFilename    : string;
  BlueMat       : array of array of Byte;         // ͉摜pz
  GlueMat       : array of array of Byte;
  RlueMat       : array of array of Byte;
  OBlueMat      : array of array of Byte;         // ]摜pz
  OGreenMat     : array of array of Byte;
  ORedMat       : array of array of Byte;
  BackColor     : Byte;

  LkTable       : array of array of Byte;         // `ԗpbNAbve[u



const
  OpenFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.ico;*.wdp'+
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.ico|*.ico' +
    '|*.wdp|*.wdp';

  SaveFileFilter =
    '摜t@C|*.png;*.jpg;*.gif;*.bmp;*.tif;*.wdp' +
    '|*.png|*.png' +
    '|*.jpg|*.jpg' +
    '|*.gif|*.gif' +
    '|*.bmp|*.bmp' +
    '|*.tif|*.tif' +
    '|*.wdp|*.wdp';

//**************************************************
// bNAbve[ũf[^[Zbg
//**************************************************
procedure TForm1.MakeLookUp;
var
  II, JJ : Integer;
begin
  SetLength(LkTable, 511, 256);               // 511 = -255 ` 255  256 = 0 ` 255
  for II := -255 to 255 do
    for JJ := 0 to 255 do
      LkTable[II + 255, JJ] := (JJ * II) div 255;
end;

//**********************************************************************
// bNAbve[u
// diff f[^[(-255`255)  Ki ␳W(0`255) Bas x[X(0`255)
//**********************************************************************
function TForm1.LooK_UP(diff: Smallint; Ki, Bas: Byte): byte;
var
  difpos  : Smallint;
begin
  difpos  := diff + 255;                      // l-255 ` 255 Ȃ̂ 255 ZĔzY̒lɂ܂
  Result  := LkTable[difpos , Ki] + Bas;      // z񂩂Wƍl̒l悶loA{lZ܂
end;

//**************************************************
// t@C̃I[vƕ\
//**************************************************
procedure TForm1.FileOpenBtnClick(Sender: TObject);
var
  WIC         : TWICImage;
  IHeight     : Integer;
  IWidth      : Integer;
  PBA         : PByteArray;
  HH, WW      : Integer;
  PosP        : Integer;
begin
  FileOpenBtn.Enabled := False;
  // 摜̉ʂ̏
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clWhite;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜

  OpenPictureDialog1.Filter := OpenFileFilter;                // t@CI[vtB^[̐ݒ
  // t@C̃I[v
  if OpenPictureDialog1.Execute then                          // t@Cw肳ꂽ
    begin
      WIC := TWICImage.Create;                                // TWICImage̐
      try
        InFilename := OpenPictureDialog1.FileName;            // t@C̎擾
        WIC.LoadFromFile(InFilename);                         // 摜̓ǂݍ
        GHeight := WIC.Height;                                // 摜擾
        GWidth  := WIC.Width;                                 // 摜
        // ̓f[^[\w肾
        if CheckBox2.Checked then begin
          IWidth  := Image1.Width;                            // o͐C[W1̕
          IHeight := Image1.Height;                           // o͐C[W1̍
          if GHeight <= GWidth then begin                     // cɂo̓TCYݒ
            IHeight := Round(IWidth * GHeight / GWidth);
          end
          else
          begin
            IWidth := Round(IHeight * GWidth / GHeight);
          end;
          VRect := Rect(0, 0, IWidth, IHeight);               // o͘gݒ
          Image1.Canvas.StretchDraw(VRect, WIC);              // o͘gɕϔ{o
        end;

        InputDBitmap.Assign(WIC);
      finally
        WIC.Free;                                             // TWICImage 
      end;
    end;
  // ͉摜f[^[pzm
  SetLength(BlueMat, GHeight + 1, GWidth + 1);                // `Ԃׂ̈PPsg܂
  SetLength(GlueMat, GHeight + 1, GWidth + 1);                // ԌvZꍇAԂ̒lKvȂ
  SetLength(RlueMat, GHeight + 1, GWidth + 1);                // PsAP񂻂ꂼŝŒǉf
  // ͉摜zɕۑ                                     // [^[܂B
  for HH := 0 to GHeight - 1 do begin
    PBA := InputDBitmap.ScanLine[HH];
    for WW := 0 to GWidth - 1 do begin
      PosP := WW * 4;
      BlueMat[HH, WW] := PBA[PosP];
      GlueMat[HH, WW] := PBA[PosP + 1];
      RlueMat[HH, WW] := PBA[PosP + 2];
    end;
  end;
  // zgɗׂ̍sRs[
  for WW := 0 to GWidth do begin
    BlueMat[GHeight, WW] := BlueMat[GHeight - 1, WW];
    GlueMat[GHeight, WW] := GlueMat[GHeight - 1, WW];
    RlueMat[GHeight, WW] := RlueMat[GHeight - 1, WW];
  end;
  // zgɗׂ̗Rs[
  for HH := 0 to GHeight do begin
    BlueMat[HH, GWidth]  := BlueMat[HH, GWidth - 1];
    GlueMat[HH, GWidth]  := GlueMat[HH, GWidth - 1];
    RlueMat[HH, GWidth]  := RlueMat[HH, GWidth - 1];
  end;

  FileOpenBtn.Enabled := True;
  if CheckBox2.Checked then
    Rotationbtn.Enabled := True
  else
    RotationbtnClick(nil);
end;

//*******************************************************
// 摜̉]ƕ\
//*******************************************************
procedure TForm1.RotationbtnClick(Sender: TObject);
var
  Angle               : Double;                               // px
  Indeg               : Double;                               // px͒l Pʓx
  I                   : Integer;                              // px̓G[mFp
  W, H                : Double;                               // ]rbg}bvƍvZp
  SCentX,   ScentY    : Integer;                              // 摜SW
  DHeight,  DWidth    : Integer;                              // ]摜
  ValCos,   ValSin    : Double;                               // sin,cos
  IntCos,   IntSin    : Integer;                              // sin,cos l
  Yo, Xo              : Integer;                              // ]摜W
  Yi, Xi              : Integer;                              // 摜W
  PBA                 : PByteArray;                           // oCgz|C^[
  PosP                : Integer;
  IWidth, IHeight     : Integer;
  DX, DY              : Integer;                              // ԌW
  X,  Y               : Integer;                              // 摜WvZp
  BCTL, BCTR, BCBL, BCBR  : Integer;                          // `ԌvZp
  GCTL, GCTR, GCBL, GCBR  : Integer;
  RCTL, RCTR, RCBL, RCBR  : Integer;
  BTOP, BBOTOM          : Integer;
  GTOP, GBOTOM          : Integer;
  RTOP, RBOTOM          : Integer;
  BDD, GDD, RDD         : Integer;                             // `ԌvZ
  BXo, BYo              : Integer;

const
  BIRiTu  = 1024;                                              // p{
  Shift10 =   10;                                              // 1024 Vtg
  Shift2  =    2;                                              // 1024 -> 256 Vtg
  Shift1  =    1;                                              // Vtg 1rbg

begin
  Rotationbtn.Enabled := False;
  Val(DeginEdit.Text, Indeg, I);
  if I <> 0 then begin
    application.MessageBox('͒lɌ肪܂B','', 0);
    Rotationbtn.Enabled := True;
    exit;
  end;
  Angle := DegToRad(Indeg);                                   // ]px
  VRect := Rect(0, 0, Image1.Width, Image1.Height);
  // \摜̏
  Image1.Canvas.Brush.Style := bsSolid;
  Image1.Canvas.Brush.Color := clBtnFace;
  Image1.Canvas.FillRect(VRect);                              // Canvas 摜

  ValCos := Cos(Angle);                                       // ]pݒ
  ValSin := Sin(Angle);
  // ]̉摜pTbitmap̐ݒ
  W := abs(ValSin) * GHeight + abs(ValCos) * GWidth + 4;          // ]̃rbg}bvvZ  @+4 SẲ摜gɓ悤ݒ
  H := abs(ValCos) * GHeight + abs(ValSin) * GWidth + 4;          // JX̃rbg}bvvZ  +4 SẲ摜gɓ悤ݒ
  // o͗pTBitmap ̐ݒ
  OutputBitmap.Assign(nil);                                   // TBitmap̏
  OutputBitmap.PixelFormat := pf24bit;                        // TBitmap̃tH[}bgݒ
  OutputBitmap.Height := Round(H);
  OutputBitmap.Width  := Round(W);
  DHeight := OutputBitmap.Height;
  DWidth  := OutputBitmap.Width;
  // ]摜ݗpzm
  SetLength(OBlueMat,  DHeight + 1, DWidth);
  SetLength(OGreenMat, DHeight + 1, DWidth);
  SetLength(ORedMat,   DHeight + 1, DWidth );
  // 摜Sʒuݒ 񕪂̈ɂĒSɂƊ̎ʒuvẐœ{̒lgp܂B
  SCentX := GWidth  * BIRiTu;               // Xc Sʒu
  ScentY := GHeight * BIRiTu;               // Yc Sʒu
  // vZp@Cos Sin ̐l
  IntCos := Round(ValCos * BIRiTu);
  IntSin := Round(ValSin * BIRiTu);

  for Yo := 0 to DHeight - 1 do begin
    for Xo := 0 to DWidth - 1 do begin
      BXo := Xo shl Shift1;                 // 2{ɂ܂
      BYo := Yo shl Shift1;
      // ]W Xo,Yo ɑ΂ W  Xi,Yi vZ X,Y  BIRiTu@ l
      // BXo BYo  Q{l DWidth,DHeight ̎ Sʒûh~܂
      // ʂ̒̒lQ{ɂȂ̂ E1rbgVtg܂@
      X := ((((BXo - DWidth) * IntCos - (BYo - DHeight) * IntSin)) + SCentX) shr Shift1;
      Y := ((((BXo - DWidth) * IntSin + (BYo - DHeight) * IntCos)) + SCentY) shr Shift1;

      Xi :=  X shr Shift10;                               // 摜W Xi ɂ  WɂȂ܂
      Yi :=  Y shr Shift10;                               // 摜W Yi ɂ  WɂȂ܂

      // `ԌvZ X,Y ̒l 0  0 傫 vZ܂B
      // Xi,Yi  fƁADX@Dy  }CiXƂȂ鎞܂B
      // 摜̔zWidth y Height ́A\[XǂݍݎPyтPsgĂ܂B
      if (X >= 0) and (Y >= 0) and (Xi < GWidth) and (Yi < GHeight) then  begin
        // `ԌvZ
        if not CheckBox1.Checked then begin
          // _Zď_ȉ̒l1024{lƓlo܂E
          // DX,DY ̒l 0 ` 1023̒lȂ̂ōXɉEVtg 0`255̒lɂ܂ bNAbve[upɂ܂
          DX := (X - Xi shl Shift10) shr Shift2;;     // X̒[Cʒu XԌW
          DY := (Y - Yi shl Shift10) shr Shift2;;     // Y̒[Cʒu YԌW

          // 
          BCTL := BlueMat[Yi, Xi];
          GCTL := GlueMat[Yi, Xi];
          RCTL := RlueMat[Yi, Xi];
          // E
          BCTR := BlueMat[Yi, Xi + 1];
          GCTR := GlueMat[Yi, Xi + 1];
          RCTR := RlueMat[Yi, Xi + 1];
          // 
          BCBL := BlueMat[Yi + 1, Xi];
          GCBL := GlueMat[Yi + 1, Xi];
          RCBL := RlueMat[Yi + 1, Xi];
          // E
          BCBR := BlueMat[Yi + 1, Xi + 1];
          GCBR := GlueMat[Yi + 1, Xi + 1];
          RCBR := RlueMat[Yi + 1, Xi + 1];

          // 㑤 `
          BTOP := LooK_UP(BCTR - BCTL, DX, BCTL);
          GTOP := LooK_UP(GCTR - GCTL, DX, GCTL);
          RTOP := LooK_UP(RCTR - RCTL, DX, RCTL);
          //  `
          BBOTOM := LooK_UP(BCBR - BCBL, DX, BCBL);
          GBOTOM := LooK_UP(GCBR - GCBL, DX, GCBL);
          RBOTOM := LooK_UP(RCBR - RCBL, DX, RCBL);
          // ㉺`
          BDD := LooK_UP(BBOTOM - BTOP, DY, BTOP);
          GDD := LooK_UP(GBOTOM - GTOP, DY, GTOP);
          RDD := LooK_UP(RBOTOM - RTOP, DY, RTOP);
           // zɕۑ
          OBlueMat[Yo, Xo]  := BDD;
          OGreenMat[Yo, Xo] := GDD;
          ORedMat[Yo, Xo]   := RDD;
        end
        else begin    // `ԂłȂwW̒l̂܂܃Zbg܂
          OBlueMat[Yo, Xo]  := BlueMat[Yi, Xi];
          OGreenMat[Yo, Xo] := GlueMat[Yi, Xi];
          ORedMat[Yo, Xo]   := RlueMat[Yi, Xi];
        end;
      end
      else begin    // 摜͈̔͊Ow肳ꂽFɂ܂B0`255 ̒lłB
        OBlueMat[Yo, Xo]  := BackColor;
        OGreenMat[Yo, Xo] := BackColor;
        ORedMat[Yo, Xo]   := BackColor;
      end;
//      application.ProcessMessages;
    end;
    application.ProcessMessages;
  end;

  // ]zTBitmapɃRs[
  for Yo := 0 to DHeight - 1 do begin
    PBA := OutputBitmap.ScanLine[Yo];
    for Xo := 0 to DWidth - 1 do begin
      PosP := Xo * 3;
      PBA[PosP]     := OBlueMat[Yo, Xo];
      PBA[PosP + 1] := OGreenMat[Yo, Xo];
      PBA[PosP + 2] := ORedMat[Yo, Xo];
    end;
  end;

  IWidth  := Image1.Width;                         // o͐C[W1̕
  IHeight := Image1.Height;                        // o͐C[W1̍
  if DHeight <= DWidth then                        // cɂo̓TCYݒ
    IHeight := Round(IWidth * DHeight / DWidth)
  else
    IWidth := Round(IHeight * DWidth / DHeight);
  VRect := Rect(0, 0, IWidth, IHeight);                   // o͘gݒ
  Image1.Canvas.StretchDraw(VRect, OutputBitmap);         // o͘gɕϔ{o
  Rotationbtn.Enabled := True;
end;

procedure TForm1.ScrollBar1Change(Sender: TObject);
begin
  BackColor := ScrollBar1.Position;
end;

procedure TForm1.ScrollBar2Change(Sender: TObject);
begin
  DeginEdit.Text := intTostr(ScrollBar2.Position);
end;

//****************************************************

procedure TForm1.FormCreate(Sender: TObject);
var
  ABitmap : TBitmap;
begin
  Top  := (Screen.Height - Height) div 2;
  Left := (Screen.Width  - Width)  div 2;
  Image1.Height := 512;
  Image1.Width  := 512;
  // ͂̕ȂĂɖȂ
  ABitmap := TBitmap.Create;
  try
    ABitmap.Width   := Image1.Width;
    ABitmap.Height  := Image1.Height;
    Image1.Picture.Graphic := ABitmap;    // GraphicBitmap̊t
  finally
    ABitmap.Free;
  end;
  // ܂
  InputDBitmap := Tbitmap.Create;
  OutputBitmap := Tbitmap.Create;
  MakeLookUp;
  Rotationbtn.Enabled := False;
  ScrollBar1.Position := 255;
  BackColor := ScrollBar1.Position;
  DeginEdit.Text := intTostr(ScrollBar2.Position);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  InputDBitmap.Free;
  OutputBitmap.Free;
end;


end.
